



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++_系列自学课程_第_6_课_bitset集_《C++ Primer 第四版》</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++_系列自学课程_第_6_课_bitset集_《C++ Primer 第四版》</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:54:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在C语言中要对一个整数的某一个位进行操作需要用到很多的技巧。这种情况在C++里面通过标准库提供的一个抽象数据类型</p>
<p>bitset得到了改善。</p>
<p>一、标准库bitset类型</p>
<p>1、bitset的作用</p>
<p>　　bitset可以看成bit的集合，可以单独的访问集合中的某一位，访问的结果可以作为逻辑的判断的条件。使用bitset的时候可以</p>
<p>不关心这些bit的存储方式，而通过bitset类型提供的一套接口进行操作。</p>
<p>　　和string和vector一样，要使用bitset类型，需要报备，如下所示：</p>
<div>
<pre class="prettyprint linenums">#include &lt;bitset&gt;     //包含相关的头文件<br />
#using std::bitset;   //声明使用相应的命名空间的名字</pre>
</div>
<p>2、bitset的定义</p>
<p>　 在定义bitset对象的时候，需要指出bitset对象要存储多少bit， 这通过在bitset后面的&lt;&gt;中设置，如下所示：</p>
<div>
<pre class="prettyprint linenums">bitset&lt;n&gt;  bitTset;  //定义一个bitset对象bitTest, n为对象可以存储的bit的位数</pre>
</div>
<p>Exp:</p>
<p>　　bitset&lt;16&gt; &nbsp;b16Test; &nbsp; //&nbsp;定义存储16bit 的 bitset的对象</p>
<p>　　bitset&lt;32&gt; &nbsp;b32Test; &nbsp; //定义存储32bit的bitset对象</p>
<p><strong>要点：</strong></p>
<p><strong>　　bitset&lt;n&gt; &nbsp;bitObj; &nbsp;定义的时候n的值必须是一个整型字面值或者用整型字面值初始化的const对象，不能是变量，这一点</strong></p>
<p><strong>必须要注意。</strong></p>
<p>Exp:</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    bitset&lt;&gt; bitObj();

    cout&lt;&lt;bitObj&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p>执行结果如下所示：</p>
<div>
<pre class="prettyprint linenums">[root@localhost cpp_src]# g++ test.cpp<br />
[root@localhost cpp_src]# ./a.out
</pre>
</div>
<p>3、bitset类的初始化</p>
<p>　　bitset提供了多种初始化的方法，如下所示：</p>
<p>　　bitset&lt;n&gt; &nbsp;bitsetObj1; &nbsp; &nbsp; &nbsp; &nbsp;//初始化bitset对象bitsetObj1的所有的bit为0；</p>
<p>　　bitset&lt;n&gt; &nbsp;bitsetObj2(u); &nbsp; &nbsp;//利用无符号数整型数 u 来初始化bitset对象bitsetObj2；</p>
<p>bitset&lt;n&gt; &nbsp;bitsetObj3(string); &nbsp;//利用string对象初始化bitset对象bitsetObj3；</p>
<p>　　bitset&lt;n&gt; &nbsp;bitsetObj4(string, pos, m); &nbsp;//利用string对象来初始化从pos位开始的m位</p>
<p><strong>要点：</strong></p>
<p><strong>　　利用无符号数u和string对象初始化的时候，可能会存在长度不匹配的情况。而且string对象是一个0、1组成的字符序列。</strong></p>
<p>利用无符号数初始化的时候会先将无符号数转换成二进制格式然后存储到bitset对象中； 利用string对象初始化的时候也会先将string</p>
<p>对象转换为二进制格式然后存储到bitset对象中。</p>
<p>Exp: &nbsp;初始化bitset对象</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    string str="";<br />
    bitset&lt;&gt; bitObj1;         //16个bit全为0<br />
    bitset&lt;&gt; bitObj2(0xffff); //32个bit， 高16bit的全是0， 低16bit全是1<br />
    bitset&lt;&gt;  bitObj3(str);    //这个需要在下面细说一下

    cout&lt;&lt;sizeof(0xffff)&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p><strong>　　上面的初始化中需要注意string对象的初始化的时候，不能用字符串字面值来初始化。</strong></p>
<p>　　对于 :</p>
<p>　　　　string &nbsp;str="1111_1010_1101"; //这利用 _ 分隔是为了更好的查看</p>
<p>　　　　bitset&lt;8&gt; bitObj3(str);</p>
<p>　　　　bitset&lt;32&gt; bitObj4(str);</p>
<p>　　这样初始化后 bitObj3的bit的存放的结果如下所示： &nbsp;11111010；</p>
<p>bitObj4的结果如下： &nbsp;00000000000000000000111110101101</p>
<p>　　<strong>可以发现规律： &nbsp;当string对象的长度大于bitset对象容量的时候，会将string的后半部分截断， 而保留string对象中下标相对较小</strong></p>
<p><strong>的字符序列。</strong></p>
<p><strong>　　当string对象的长度小于bitset对象的容量的时候，就将string对象全部进行转换，并且将string对象进行"平行移动"到bitset对象的</strong></p>
<p><strong>低位部分， 剩下的bitset不足的高位部分用0补齐。</strong></p>
<p>Exp:</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    string str="";<br />
    bitset&lt;&gt; bitObj1;<br />
    bitset&lt;&gt; bitObj2(0xffff);<br />
    bitset&lt;&gt;  bitObj3(str);<br />
    bitset&lt;&gt; bitObj4(str);

    cout&lt;&lt;bitObj3&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj4&lt;&lt;endl;<br />
    cout&lt;&lt;sizeof(0xffff)&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p>执行结果为：</p>
<div>
<pre class="prettyprint linenums">[root@localhost cpp_src]# g++ bitset_init.cpp<br />
[root@localhost cpp_src]# ./a.out 
</pre>
</div>
<p>Exp: &nbsp;利用部分的string的字符序列初始化bitset对象</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    string str="";<br />
    bitset&lt;&gt; bitObj1(str,,);<br />
    bitset&lt;&gt; bitObj2(str,str.size()-);

    cout&lt;&lt;bitObj1&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj2&lt;&lt;endl;<br />
    cout&lt;&lt;str.size()&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p>执行结果如下所示：</p>
<div>
<pre class="prettyprint linenums">[root@localhost cpp_src]# ./a.out 
</pre>
</div>
<p>下面解释一下这个结果：</p>
<p>　　string str("11_1111_1000_0000_1100_1101") ; //</p>
<p>　　bitset&lt;32&gt; &nbsp;bitObj1(str, 5, 4); 这个初始化的意思就是从str对象中的str[5]开始，取4个字符来初始化bitObj1对象。因为取出来的</p>
<p>字符长度小于32bit，因此遵循前面说的string长度小于bitset对象长度的赋值方法。</p>
<p>bitset&lt;32&gt; &nbsp;bitObj2(str, str.size() - 4); 这里只有两个参数，最后一个参数没有，就表示从str.size()-4开始取字符序列，一直取字</p>
<p>符到string对象的最后一个字符，然后进行转换， 而且转换过程遵循前面说过的关于string对象和bitset对象长度的赋值规则。</p>
<p>　　因此得到了上面的运行结果。</p>
<p>　　<strong>其实后面这两种的初始化主要需要注意的是如何取字符序列，字符序列取出来后，就把取出来的字符序列当成一个新的string对象进行初始</strong></p>
<p><strong>化就可以啦</strong>。</p>
<p>　　</p>
<p>4、bitset类提供的操作</p>
<p>　　和其他的标准库类一样，bitset也提供了很多的操作，主要有如下一些：</p>
<p>　　 bitset&lt;n&gt; &nbsp;bitObj;</p>
<p>　　bitObj.any( ); &nbsp; 返回bitObj对象中是否存在已经设为 1 的bit</p>
<p>　　bitObj.none(); &nbsp;返回bitObj不存在为1的二进制bit吗， 就是测试是否所有的bit全是0， 全是0时返回true</p>
<p>　　bitObj.count(); 返回bitObj中1的位数</p>
<p>　　bitObj.size()； &nbsp;返回bitObj对象的bit个数</p>
<p>　　bitObj[pos] ; &nbsp;返回bitObj的pos位置处的二进制bit的值</p>
<p>　　bitObj.set(); &nbsp; 设置为1；</p>
<p>　　bitObj.set(pos); 设置pos处的bit为1；</p>
<p>　　bitObj.reset(); &nbsp; 设置全为0；</p>
<p>　　bitObj.reset(pos); &nbsp;设置pos位置为0</p>
<p>　　bitObj.flip(); 所有的bit取反；</p>
<p>　　bitObj.flip(pos); 将pos位置处的bit取反。</p>
<p>　　bitObj.to_ulong() 将bitObj转换为unsigned long int类型</p>
<p>os&lt;&lt;b; &nbsp;将b中的bitset集输出到os流。</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    bitset&lt;&gt; bitObj();

    cout&lt;&lt;bitObj&lt;&lt;endl;<br />
    cout&lt;&lt;"The size of bitObj is:"&lt;&lt;bitObj.size()&lt;&lt;endl;<br />
    cout&lt;&lt;"bitObj.to_ulong() is:"&lt;&lt;bitObj.to_ulong()&lt;&lt;endl;

    cout&lt;&lt;"bitObj[3] is:"&lt;&lt;bitObj[]&lt;&lt;endl;

    if(bitObj.any())<br />
        cout&lt;&lt;"bitObj has some bit == 1"&lt;&lt;endl;<br />
    else<br />
        cout&lt;&lt;"bitObj has no bit == 1"&lt;&lt;endl;

    if(bitObj.none())<br />
        cout&lt;&lt;"bitObj all bit is 0."&lt;&lt;endl;<br />
    else<br />
        cout&lt;&lt;"bitObj has some bit == 1"&lt;&lt;endl;

    bitObj.set();<br />
    cout&lt;&lt;"after bit.set() bitObj is:"&lt;&lt;bitObj&lt;&lt;endl;<br />
    bitObj.reset();<br />
    cout&lt;&lt;"after bit.reset(3),the bitObj is:"&lt;&lt;bitObj&lt;&lt;endl;

    bitObj.reset();<br />
    cout&lt;&lt;"after bitObj.reset() bitObj is:"&lt;&lt;bitObj&lt;&lt;endl;<br />
    bitObj.set();<br />
    cout&lt;&lt;"after bitObj.set(4),bitObj is:"&lt;&lt;bitObj&lt;&lt;endl;

    cout&lt;&lt;"bitObj.flip() is:"&lt;&lt;bitObj.flip()&lt;&lt;endl;

    cout&lt;&lt;"bitObj is"&lt;&lt;bitObj&lt;&lt;endl;<br />
    bitObj.flip();<br />
    cout&lt;&lt;"after bitObj.flip(1),bitObj is:"&lt;&lt;bitObj&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p>执行结果如下所示：</p>
<div>
<pre class="prettyprint linenums">[root@localhost cpp_src]# ./a.out 

The size of bitObj is:<br />
bitObj.to_ulong() is:<br />
bitObj[] is:<br />
bitObj has some bit ==<br />
bitObj has some bit ==<br />
after bit.set() bitObj is:<br />
after bit.reset(),the bitObj is:<br />
after bitObj.reset() bitObj is:<br />
after bitObj.set(),bitObj is:<br />
bitObj.flip() is:<br />
bitObj is01111<br />
after bitObj.flip(),bitObj is:<br />
[root@localhost cpp_src]# </pre>
</div>
<p><strong>　　通过上面的实例可以知道两个特点需要特别的注意：</strong></p>
<p><strong>　　 b.set(n)、b.reset(n)、b.flip(n); &nbsp;这个n是从0开始计算的， 而且是从最低位开始计算的。</strong></p>
<p>　下面还有一个例子：</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    bitset&lt;&gt; bitObj();

    cout&lt;&lt;bitObj&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj[]&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj[]&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj[]&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj[]&lt;&lt;endl;<br />
    cout&lt;&lt;bitObj[]&lt;&lt;endl;

    return ;<br />
}</pre>
</div>
<p>执行结果为：</p>
<div>
<pre class="prettyprint linenums">[root@localhost cpp_src]# g++ test.cpp<br />
[root@localhost cpp_src]# ./a.out 
</pre>
</div>
<p>　　<strong>从上面的结果看，bitset的下标操作为从0开始计数，而且是从最低为开始计数的， 就是说 bitObj[0] &nbsp;表示的bitset的最低位。</strong></p>
<p>　　这次就说的这里，接下来将是与C语言相关的数组和指针的内容啦，待续.........</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2mk1l8.html">H264编码原理以及I帧、B和P帧详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdd7gvq.html">Web App适配不同屏幕的几点建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z63z1q.html">middleware中间件的概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq12e529.html">MBProgressHUD&plus;FastCall</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd36dv8.html">Meta标签实现阻止移动设备&lpar;手机、Pad&rpar;的浏览器双击放大网页</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ev6vq.html">AngularJS 学习之事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw151z8.html">JQuery 如何选择带有多个class的元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjwe5z9.html">Yii2&period;0 实现三级联动 &lbrack; 2&period;0 版本 &rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0moowq.html">start apache2 failed in Ubuntu</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xgp609.html">Android：仿微信开场切换界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgz0mr8.html">Jsunpack</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjwj69.html">用一个jsp实现对数据库发访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gezd508.html">&lbrack;ASP&period;NET MVC&rsqb;笔记（四  UnobtruSive AJAX和客户端验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2k4j9.html">&lbrack;译&rsqb; Linux吃掉了我的内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvdj4r8.html">web&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rzxxq.html">NeuroNER&plus;brat工具学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5erl4q.html">&period;&OpenCurlyDoubleQuote;代理XP&rdquo;组件已作为此服务器安全配置的一部分被关闭的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vz6x2q.html">The last access date is not changed even after reading the file on Windows 7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjz3njq.html">查看dns节点的内存是否够用</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1vne69.html">【PAT Advanced Level】1015&period; Reversible Primes &lpar;20&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93wdrzq.html">ArcGIS制作放射状流向地图（Radial Flow Map）</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqllny0q.html">自动化安装SQL Server&plus;SP就那么简单</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m2p26q.html">WCF 的 Service Instance模式和并发处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93wvdnq.html">用css画出三角形</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pw3yd8.html">&lbrack;oracle&rsqb;逗号&lpar;或分号等&rpar;间隔的列&comma;按这一列劈分后转多行</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93wvzzq.html">fir&period;im Weekly - 如何进行 Android App 性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7o27e8.html">MongoDB 文档的删除操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25ymoq.html">学习3ds max插件开发过程中的一些小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwv4wl8.html">XML实体引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7o03j8.html">【转】WPF 给DataGridTextColumn统一加上ToolTip</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
